/*

Directory Opus 4
Original GPL release version 4.12
Copyright 1993-2000 Jonathan Potter

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

All users of Directory Opus 4 (including versions distributed
under the GPL) are entitled to upgrade to the latest version of
Directory Opus version 5 at a reduced price. Please see
http://www.gpsoft.com.au for more information.

The release of Directory Opus 4 under the GPL in NO WAY affects
the existing commercial status of Directory Opus 5.

*/

extern char **cfg_string;

enum {
	STR_REALLY_DISCARD_CONFIG,
	STR_EXIT_WITHOUT_SAVING,
	STR_CONFIGURATION_MAIN_SCREEN,
	STR_OPERATION_SCREEN,
	STR_MENU_SCREEN,
	STR_DRIVE_SCREEN,
	STR_FILETYPE_SCREEN,
	STR_SCREEN_SCREEN,
	STR_SYSTEM_SCREEN,
	STR_HOTKEYS_SCREEN,
	STR_MAIN_MENU,
	STR_LEFT_MOUSE_BUTTON,
	STR_RIGHT_MOUSE_BUTTON,
	STR_OKAY,
	STR_CANCEL,
	STR_AVAILABLE_DISPLAY_ITEMS,
	STR_SELECTED_DISPLAY_ITEMS,
	STR_DISPLAYED_LENGTHS,
	STR_CHECK_INDICATES_SORT,
	STR_ENTRY_SEPARATION,
	STR_UNICONIFY_HOTKEY,
	STR_PROJECTS_DEFAULT_TOOL,
	STR_SELECT_DESIRED_FILE,
	STR_SELECT_DESIRED_DIRECTORY,
	STR_SELECT_DESIRED_FONT,
	STR_HOTKEY_USCORE,
	STR_NEW_GADGET_BANKS_APPENDED,
	STR_DEFAULT_GADGET_BANKS_APPENDED,
	STR_NO_GADGET_BANKS_CONFIGURED,
	STR_GADGET_DELETED,
	STR_SELECT_GADGET_TO_COPY,
	STR_SELECT_GADGET_TO_SWAP,
	STR_SELECT_A_GADGET_TO_COPY,
	STR_SELECT_FIRST_GADGET_TO_SWAP,
	STR_GADGET_EDIT_SCREEN,
	STR_ENTER_BANK_TO_COPY,
	STR_BANK_ALREADY_EXISTS,
	STR_GADGET_BANK_COPIED,
	STR_ENTER_BANK_TO_SWAP,
	STR_BANK_DOES_NOT_EXIST,
	STR_BANKS_SWAPPED,
	STR_ONLY_BANK_CONFIGURED,
	STR_REALLY_DELETE_BANK,
	STR_BANK_DELETED,
	STR_SELECT_GADGET_TO_DELETE,
	STR_GADGET_BANK_NUMBER,
	STR_GADGET_SCREEN_NO_BANKS,
	STR_NO_MEMORY_FOR_NEW_BANK,
	STR_NEW_BANK_CREATED,
	STR_NEW_MENUS_LOADED,
	STR_DEFAULT_MENUS_LOADED,
	STR_ENTER_MENU_TITLE,
	STR_MENU_ITEM_DELETED,
	STR_MENU_ITEM_INSERTED,
	STR_REALLY_DELETE_THIS_MENU,
	STR_MENU_DELETED,
	STR_MENU_SORTED,
	STR_SELECT_MENU_TO_COPY,
	STR_SELECT_MENU_TO_SWAP,
	STR_SELECT_ITEM_TO_COPY,
	STR_SELECT_ITEM_TO_SWAP,
	STR_MENU_ITEM_EDIT_SCREEN,
	STR_SELECT_ITEM_IN_MENU_TO_COPY,
	STR_SELECT_ITEM_IN_MENU_TO_SWAP,
	STR_SELECT_ITEM_IN_MENU_TO_DELETE,
	STR_SELECT_ITEM_IN_MENU_TO_SORT,
	STR_SELECT_ITEM_TO_INSERT_BEFORE,
	STR_SELECT_MENU_ITEM_TO_COPY,
	STR_SELECT_MENU_ITEM_TO_SWAP,
	STR_SELECT_MENU_ITEM_TO_DELETE,
	STR_EDIT,
	STR_SHORTCUT_KEY,
	STR_HOTKEY,
	STR_ARGUMENT_CONTROL_SEQUENCES,
	STR_AVAILABLE_COMMANDS,
	STR_FOREGROUND,
	STR_BACKGROUND,
	STR_DROP_A_TOOL_HERE,
	STR_NEW_DRIVE_BANKS_LOADED,
	STR_DEFAULT_DRIVE_BANKS_RESET,
	STR_DRIVE_GADGET_DELETED,
	STR_SELECT_DRIVE_TO_COPY_TO,
	STR_SELECT_DRIVE_TO_SWAP_WITH_FIRST,
	STR_SELECT_DRIVE_BANK_TO_COPY_TO,
	STR_SELECT_DRIVE_BANK_TO_SWAP_WITH_FIRST,
	STR_REALLY_DELETE_DRIVE_BANK,
	STR_PATH,
	STR_SYSTEM_DEVICES_LISTED,
	STR_SELECT_DRIVE_BANK_TO_COPY,
	STR_SELECT_DRIVE_BANK_TO_SWAP,
	STR_SELECT_DRIVE_BANK_TO_DELETE,
	STR_SELECT_DRIVE_BANK_TO_SORT,
	STR_SELECT_DRIVE_GADGET_TO_COPY,
	STR_SELECT_DRIVE_GADGET_TO_SWAP,
	STR_SELECT_DRIVE_GADGET_TO_DELETE,
	STR_NEW_FILETYPES_MERGED,
	STR_DEFAULT_FILETYPES_MERGED,
	STR_REALLY_DELETE_THIS_CLASS,
	STR_FILE_CLASS_DELETED,
	STR_SELECT_CLASS_FILE_TO_LOAD,
	STR_ENTER_NAME_TO_SAVE_CLASSES,
	STR_SELECT_CLASSES_TO_IMPORT,
	STR_ERASE_ALL_CLASSES,
	STR_EXIT_WITHOUT_SAVING_CLASSES,
	STR_REDEFINE_EXISTING_CLASS_ACTION,
	STR_DEFAULT_ACTION_CAN_NOT_BE_MOVED,
	STR_CLASS_ACTIONS_SWAPPED,
	STR_SELECT_ACTION_TO_SWAP,
	STR_SELECT_ACTION_TO_SWAP_WITH_FIRST,
	STR_SELECT_ACTION_TO_DELETE,
	STR_REALLY_DELETE_THIS_ACTION,
	STR_ACTION_DELETED,
	STR_FILETYPE_CLASS,
	STR_EDIT_CLASS,
	STR_FILE_CLASS_EDIT_SCREEN,
	STR_OPEN_FAILED,
	STR_SAVE_FAILED,
	STR_LIST_OF_FILETYPE_COMMANDS,
	STR_POSITION,
	STR_OFFSET,
	STR_FILE_NOT_FOUND,
	STR_EXAMPLE,
	STR_DISPLAY_MODE_DESCRIPTION,
	STR_DISPLAY_ITEM,
	STR_FONT,
	STR_FONT_SIZE,
	STR_MODIFY_SIZE,
	STR_USE_MMB,
	STR_MINIMUM_SIZE,
	STR_MAXIMUM_SIZE,
	STR_DEFAULT_SIZE,
	STR_MAXIMUM_COLORS,
	STR_LOADING_FONT,
	STR_FONT_COULD_NOT_BE_LOADED,
	STR_ENTER_CONFIGURATION_FILENAME,
	STR_SELECT_CONFIGURATION_TO_LOAD,
	STR_FILE_NOT_VALID_CONFIGURATION,
	STR_SELECT_MENUS_TO_IMPORT,
	STR_SELECT_FILETYPES_TO_IMPORT,
	STR_SELECT_HOTKEYS_TO_IMPORT,
	STR_SELECT_FUNCTION_TO_PASTE,
	STR_NEW_HOTKEYS_MERGED,
	STR_DEFAULT_HOTKEYS_MERGED,
	STR_SELECT_HOTKEY_TO_DELETE,
	STR_SELECT_HOTKEY_TO_DUPLICATE,
	STR_REALLY_DELETE_HOTKEY,
	STR_HOTKEY_DELETED,
	STR_HOTKEY_EDIT_SCREEN,
	STR_NEW_BANK,
	STR_INSERT_BANK,
	STR_NEXT_BANK,
	STR_LAST_BANK,
	STR_CLEAR,
	STR_CLEAR_LAST,
	STR_MENU_DEFAULT,
	STR_MENU_OPEN,
	STR_MENU_SAVE,
	STR_MENU_SAVE_AS,
	STR_MENU_CUT,
	STR_MENU_COPY,
	STR_MENU_PASTE,
	STR_MENU_ERASE,
	STR_MENU_NEW,
	STR_MENU_EDIT,
	STR_MENU_DELETE,
	STR_GADGETROWS_NONE,
	STR_GADGETROWS_ONE,
	STR_GADGETROWS_TWO,
	STR_GADGETROWS_THREE,
	STR_GADGETROWS_SIX,
	STR_MENUNAME_CONFIGURE,
	STR_MENUNAME_GADGETROWS,
	STR_MENUNAME_CLASSES,
	STR_FILECLASS_DEFINE,
	STR_FILECLASS_EDIT,
	STR_FILECLASS_DELETE,
	STR_FONTPLACE_CLOCK,
	STR_FONTPLACE_GADGETS,
	STR_FONTPLACE_MENUS,
	STR_FONTPLACE_DISKNAMES,
	STR_FONTPLACE_WINDOW,
	STR_FONTPLACE_GENERAL,
	STR_FONTPLACE_ICONIFY,
	STR_FONTPLACE_PATHS,
	STR_FONTPLACE_REQUESTERS,
	STR_FONTPLACE_STATUS,
	STR_FONTPLACE_TEXTVIEWER,
	STR_PALETTE_PRESETS,
	STR_ICONLIST_TITLE,
	STR_FORMAT_NAME,
	STR_FORMAT_SIZE,
	STR_FORMAT_BITS,
	STR_FORMAT_DATE,
	STR_FORMAT_COMMENT,
	STR_FORMAT_TYPE,
	STR_ICONS_DRAWER,
	STR_ICONS_TOOL,
	STR_ICONS_PROJECT,
	STR_MAINMENU_GADGETS,
	STR_MAINMENU_DRIVES,
	STR_MAINMENU_FILETYPES,
	STR_MAINMENU_HOTKEYS,
	STR_MAINMENU_MENUS,
	STR_MAINMENU_OPERATION,
	STR_MAINMENU_SCREEN,
	STR_MAINMENU_SYSTEM,
	STR_ALL,
	STR_OPERATION_DATEFORMAT,
	STR_OPERATION_DELETE,
	STR_OPERATION_ERRORCHECK,
	STR_OPERATION_GENERAL,
	STR_OPERATION_ICONS,
	STR_OPERATION_LISTFORMAT,
	STR_OPERATION_UPDATE,
	STR_SYSTEM_AMIGADOS,
	STR_SYSTEM_CLOCKS,
	STR_SYSTEM_DIRECTORIES,
	STR_SYSTEM_ICONS,
	STR_SYSTEM_MODULES,
	STR_SYSTEM_SHOWPATTERN,
	STR_SYSTEM_STARTUP,
	STR_SYSTEM_VIEWPLAY,
	STR_GADGET_COPYBANK,
	STR_GADGET_SWAPBANK,
	STR_GADGET_DELETEBANK,
	STR_GADGET_COPYGADGET,
	STR_GADGET_SWAPGADGET,
	STR_GADGET_DELETEGADGET,
	STR_FLAG_AUTOICONIFY,
	STR_FLAG_CDDESTINATION,
	STR_FLAG_CDSOURCE,
	STR_FLAG_DOPUSTOFRONT,
	STR_FLAG_DOALLFILES,
	STR_FLAG_INCLUDEDOPUS,
	STR_FLAG_INCLUDESHELL,
	STR_FLAG_NOQUOTE,
	STR_FLAG_OUTPUTFILE,
	STR_FLAG_OUTPUTWINDOW,
	STR_FLAG_RECURSIVE,
	STR_FLAG_RELOAD,
	STR_FLAG_RESCANDEST,
	STR_FLAG_RESCANSOURCE,
	STR_FLAG_RUNASYNC,
	STR_FLAG_WORKBENCHTOFRONT,
	STR_EDIT_NAME,
	STR_EDIT_SAMPLE,
	STR_EDIT_NEWENTRY,
	STR_EDIT_DUPLICATE,
	STR_EDIT_SWAP,
	STR_EDIT_STACKSIZE,
	STR_EDIT_PRIORITY,
	STR_EDIT_CLOSEDELAY,
	STR_EDIT_ACTION,
	STR_EDITCLASS_FILECLASS,
	STR_EDITCLASS_CLASSID,
	STR_EDITCLASS_FILEVIEWER,
	STR_MENU_COPYMENU,
	STR_MENU_SWAPMENU,
	STR_MENU_DELETEMENU,
	STR_MENU_SORTMENU,
	STR_MENU_INSERTITEM,
	STR_MENU_COPYITEM,
	STR_MENU_SWAPITEM,
	STR_MENU_DELETEITEM,
	STR_DRIVES_GETDRIVES,
	STR_DRIVES_SORTBANK,
	STR_DRIVES_COPYDRIVE,
	STR_DRIVES_SWAPDRIVE,
	STR_DRIVES_DELETEDRIVE,
	STR_HOTKEYS_NEWHOTKEY,
	STR_SCREEN_COLORS,
	STR_SCREEN_FONTS,
	STR_SCREEN_PALETTE,
	STR_SCREEN_SCREENMODE,
	STR_PALETTE_RED,
	STR_PALETTE_GREEN,
	STR_PALETTE_BLUE,
	STR_COLOR_STATUS,
	STR_COLOR_SELDISK,
	STR_COLOR_UNSELDISK,
	STR_COLOR_SELDIR,
	STR_COLOR_UNSELDIR,
	STR_COLOR_SELFILE,
	STR_COLOR_UNSELFILE,
	STR_COLOR_SLIDERS,
	STR_COLOR_ARROWS,
	STR_COLOR_TINY,
	STR_COLOR_CLOCK,
	STR_COLOR_REQUESTER,
	STR_COLOR_BOXES,
	STR_COLOR_PATHNAME,
	STR_COLOR_SELPATHNAME,
	STR_SCREENMODE_WIDTH,
	STR_SCREENMODE_HEIGHT,
	STR_SCREENMODE_COLORS,
	STR_SCREENMODE_DEFAULT,
	STR_SCREENMODE_HALFHEIGHT,
	STR_LISTFORMAT_TITLE,
	STR_LISTFORMAT_RESET,
	STR_LISTFORMAT_NAME,
	STR_LISTFORMAT_COMMENT,
	STR_LISTFORMAT_REVERSE,
	STR_ARROWS_INSIDE,
	STR_ARROWS_OUTSIDE,
	STR_ARROWS_EACH,
	STR_ARROWTYPE_UPDOWN,
	STR_ARROWTYPE_LEFTRIGHT,
	STR_ARROWTYPE_PREVNEXT,
	STR_NEW,
	STR_MISC_FLAGS,
	STR_OP_COPY_WHENCOPYING,
	STR_OP_COPY_CHECKDEST,
	STR_OP_COPY_SETARCHIVE,
	STR_OP_COPY_ALSOCOPY,
	STR_OP_COPY_DATESTAMP,
	STR_OP_COPY_BITS,
	STR_OP_COPY_COMMENT,
	STR_OP_COPY_IFFILEEXISTS,
	STR_OP_COPY_ALWAYSREPLACE,
	STR_OP_COPY_NEVERREPLACE,
	STR_OP_COPY_ONLYOLDER,
	STR_OP_COPY_ASKBEFORE,
	STR_OP_DATE_DATEFORMAT,
	STR_OP_DATE_DDMMMYY,
	STR_OP_DATE_YYMMDD,
	STR_OP_DATE_MMDDYY,
	STR_OP_DATE_DDMMYY,
	STR_OP_DATE_NAMESUB,
	STR_OP_DATE_12HOUR,
	STR_OP_DEL_ASKBEFORE,
	STR_OP_DEL_COMMENCING,
	STR_OP_DEL_DELETEFILES,
	STR_OP_DEL_DELETEDIRS,
	STR_OP_DEL_IGNOREPROT,
	STR_OP_ERROR_ENABLE,
	STR_OP_ERROR_DOSREQ,
	STR_OP_ERROR_OPUSREQ,
	STR_OP_GENERAL_DRAG,
	STR_OP_GENERAL_DISPLAYINFO,
	STR_OP_GENERAL_DOUBLECLICK,
	STR_OP_GENERAL_SLIDERACTIVE,
	STR_OP_ICON_CREATEWITHDIR,
	STR_OP_ICON_DOUNTOICONS,
	STR_OP_ICON_SELECTAUTO,
	STR_OP_UPDATE_WHENPROCESSING,
	STR_OP_UPDATE_PROGRESSIND,
	STR_OP_UPDATE_LEFTJUSTIFY,
	STR_OP_UPDATE_SCROLLTOFOLLOW,
	STR_OP_UPDATE_UPDATEFREE,
	STR_OP_UPDATE_STARTNOTIFY,
	STR_OP_UPDATE_REDRAWMORE,
	STR_SYS_AMIGADOS_TITLE,
	STR_SYS_AMIGADOS_SHELL,
	STR_SYS_AMIGADOS_CONSOLE,
	STR_SYS_AMIGADOS_STARTUP,
	STR_SYS_AMIGADOS_PRIORITY,
	STR_SYS_CLOCK_TITLE,
	STR_SYS_CLOCK_MEMORY,
	STR_SYS_CLOCK_CPUMONITOR,
	STR_SYS_CLOCK_DATE,
	STR_SYS_CLOCK_TIME,
	STR_SYS_CLOCK_WHENICONIFIED,
	STR_SYS_CLOCK_WINDOW,
	STR_SYS_CLOCK_NOWINDOW,
	STR_SYS_CLOCK_APPICON,
	STR_SYS_CLOCK_SHOWFREEAS,
	STR_SYS_CLOCK_BYTES,
	STR_SYS_CLOCK_KILOBYTES,
	STR_SYS_CLOCK_TEXTFORMAT,
	STR_SYS_CLOCK_CHIPANDFAST,
	STR_SYS_CLOCK_CANDF,
	STR_SYS_DIR_CACHES,
	STR_SYS_DIR_NUMBUFFERS,
	STR_SYS_DIR_ALWAYSEMPTY,
	STR_SYS_DIR_REREADINCOMPLETE,
	STR_SYS_DIR_SEARCHBUFFERS,
	STR_SYS_DIR_SEARCHPARENT,
	STR_SYS_DIR_DIRREAD,
	STR_SYS_DIR_AUTODISKCHANGE,
	STR_SYS_DIR_AUTODISKLOAD,
	STR_SYS_DIR_EXPANDPATHS,
	STR_SYS_DIR_USEEXALL,
	STR_FILEVIEW_HEX,
	STR_SYS_DIR_BLOCKSFREE,
	STR_SYS_DIR_PERCENTAGE,
	STR_PALETTE_RESET,
	STR_PALETTE_DOPUS_DEFAULT,
	STR_PALETTE_WB_DEFAULT,
	STR_PALETTE_WB_CURRENT,
	STR_OKAY_TO_QUIT,
	STR_SCREEN_GENERAL,
	STR_FTYPE_ACTION,
	STR_FTYPE_COMMAND,
	STR_FILEVIEW_DEC,
	STR_EDIT_MENU,
	STR_SYS_SHOWPATTERN_TITLE,
	STR_SYS_SHOWPATTERN_HIDDENBIT,
	STR_SYS_SHOWPATTERN_SHOW,
	STR_SYS_SHOWPATTERN_HIDE,
	STR_SYS_STARTUP_TITLE,
	STR_SYS_STARTUP_LEFT,
	STR_SYS_STARTUP_RIGHT,
	STR_SYS_STARTUP_AREXX,
	STR_SYS_STARTUP_STARTUP,
	STR_SYS_STARTUP_UNICONIFY,
	STR_SYS_VIEWPLAY_TITLE,
	STR_SYS_VIEWPLAY_BLACK,
	STR_SYS_VIEWPLAY_PAUSED,
	STR_SYS_VIEWPLAY_8BITCOL,
	STR_SYS_VIEWPLAY_SHOWDELAY,
	STR_SYS_VIEWPLAY_FADEDELAY,
	STR_SYS_VIEWPLAY_SOUNDPLAYER,
	STR_SYS_VIEWPLAY_FILTER,
	STR_SYS_VIEWPLAY_LOOP,
	STR_SYS_VIEWPLAY_TEXTVIEW,
	STR_SYS_VIEWPLAY_BORDERS,
	STR_SYS_VIEWPLAY_TABSIZE,
	STR_removed_0,
	STR_SCREEN_GENERAL_TINYGADS,
	STR_SCREEN_GENERAL_GADGETSLIDERS,
	STR_SCREEN_GENERAL_INDICATERMB,
	STR_SCREEN_GENERAL_NEWLOOKSLIDERS,
	STR_EDITLIST_TITLE1,
	STR_EDITLIST_TITLE2,
	STR_FILETYPEACTIONLIST_TITLE,
	STR_HOTKEYSLIST_TITLE,
	STR_SCREENMODELIST_TITLE,
	STR_LEFT_WINDOW,
	STR_RIGHT_WINDOW,
	STR_SEP_MIX_FILES,
	STR_SEP_DIRS_FIRST,
	STR_SEP_FILES_FIRST,
	STR_FUNCTIONLIST_ABOUT,
	STR_FUNCTIONLIST_ADDICON,
	STR_FUNCTIONLIST_ALARM,
	STR_FUNCTIONLIST_ALL,
	STR_FUNCTIONLIST_ANSIREAD,
	STR_FUNCTIONLIST_AREXX,
	STR_FUNCTIONLIST_ASSIGN,
	STR_FUNCTIONLIST_BEEP,
	STR_FUNCTIONLIST_BUFFERLIST,
	STR_FUNCTIONLIST_BUTTONICONIFY,
	STR_FUNCTIONLIST_CD,
	STR_FUNCTIONLIST_CHECKFIT,
	STR_FUNCTIONLIST_CLEARBUFFERS,
	STR_FUNCTIONLIST_CLEARSIZES,
	STR_FUNCTIONLIST_CLEARWIN,
	STR_FUNCTIONLIST_CLONE,
	STR_FUNCTIONLIST_COMMENT,
	STR_FUNCTIONLIST_CONFIGURE,
	STR_FUNCTIONLIST_CONTST,
	STR_FUNCTIONLIST_COPY,
	STR_FUNCTIONLIST_COPYAS,
	STR_FUNCTIONLIST_COPYWINDOW,
	STR_removed_1,
	STR_FUNCTIONLIST_DATESTAMP,
	STR_FUNCTIONLIST_DEFAULTS,
	STR_FUNCTIONLIST_DELETE,
	STR_FUNCTIONLIST_DIRTREE,
	STR_FUNCTIONLIST_DISKCOPY,
	STR_FUNCTIONLIST_DISKCOPYBG,
	STR_FUNCTIONLIST_DISKINFO,
	STR_FUNCTIONLIST_DISPLAYDIR,
	STR_FUNCTIONLIST_DOPUSTOBACK,
	STR_FUNCTIONLIST_DOPUSTOFRONT,
	STR_FUNCTIONLIST_ENCRYPT,
	STR_FUNCTIONLIST_ENDFUNCTION,
	STR_FUNCTIONLIST_ERRORHELP,
	STR_FUNCTIONLIST_EXECUTE,
	STR_FUNCTIONLIST_FORMAT,
	STR_FUNCTIONLIST_FORMATBG,
	STR_FUNCTIONLIST_GETDEVICES,
	STR_FUNCTIONLIST_GETSIZES,
	STR_FUNCTIONLIST_HELP,
	STR_FUNCTIONLIST_HEXREAD,
	STR_FUNCTIONLIST_HUNT,
	STR_FUNCTIONLIST_ICONIFY,
	STR_FUNCTIONLIST_ICONINFO,
	STR_FUNCTIONLIST_INSTALL,
	STR_FUNCTIONLIST_INSTALLBG,
	STR_FUNCTIONLIST_LASTSAVED,
	STR_FUNCTIONLIST_LOADCONFIG,
	STR_FUNCTIONLIST_LOADSTRINGS,
	STR_FUNCTIONLIST_LOOPPLAY,
	STR_FUNCTIONLIST_MAKEDIR,
	STR_FUNCTIONLIST_MODIFY,
	STR_FUNCTIONLIST_MOVE,
	STR_FUNCTIONLIST_MOVEAS,
	STR_FUNCTIONLIST_NEWCLI,
	STR_FUNCTIONLIST_NONE,
	STR_FUNCTIONLIST_OTHERWINDOW,
	STR_FUNCTIONLIST_PARENT,
	STR_FUNCTIONLIST_PLAY,
	STR_FUNCTIONLIST_PLAYST,
	STR_FUNCTIONLIST_PRINT,
	STR_FUNCTIONLIST_PRINTDIR,
	STR_FUNCTIONLIST_PROTECT,
	STR_FUNCTIONLIST_QUIT,
	STR_FUNCTIONLIST_READ,
	STR_FUNCTIONLIST_REDRAW,
	STR_FUNCTIONLIST_RELABEL,
	STR_FUNCTIONLIST_REMEMBER,
	STR_FUNCTIONLIST_RENAME,
	STR_FUNCTIONLIST_RESCAN,
	STR_FUNCTIONLIST_RESELECT,
	STR_FUNCTIONLIST_RESTORE,
	STR_FUNCTIONLIST_ROOT,
	STR_FUNCTIONLIST_RUN,
	STR_FUNCTIONLIST_SAVECONFIG,
	STR_FUNCTIONLIST_SCANDIR,
	STR_FUNCTIONLIST_SEARCH,
	STR_FUNCTIONLIST_SELECT,
	STR_FUNCTIONLIST_SHOW,
	STR_FUNCTIONLIST_SMARTREAD,
	STR_FUNCTIONLIST_STOPST,
	STR_FUNCTIONLIST_SWAPWINDOW,
	STR_FUNCTIONLIST_TOGGLE,
	STR_FUNCTIONLIST_UNICONIFY,
	STR_FUNCTIONLIST_USER_FTYPE1,
	STR_FUNCTIONLIST_USER_FTYPE2,
	STR_FUNCTIONLIST_USER_FTYPE3,
	STR_FUNCTIONLIST_USER_FTYPE4,
	STR_FUNCTIONLIST_VERIFY,
	STR_FUNCTIONLIST_VERSION,
	STR_COMMANDSEQ_DESTINATION,
	STR_COMMANDSEQ_FIRSTFILE,
	STR_COMMANDSEQ_ALLFILES,
	STR_COMMANDSEQ_FIRSTFILEUNSEL,
	STR_COMMANDSEQ_ALLFILESUNSEL,
	STR_COMMANDSEQ_FIRSTFILENOPATH,
	STR_COMMANDSEQ_ALLFILESNOPATH,
	STR_COMMANDSEQ_FIRSTFILENOPATHUNSEL,
	STR_COMMANDSEQ_ALLFILESNOPATHUNSEL,
	STR_COMMANDSEQ_PORTNAME,
	STR_COMMANDSEQ_DIRREQ,
	STR_COMMANDSEQ_FILEREQ,
	STR_COMMANDSEQ_MULTIFILEREQ,
	STR_COMMANDSEQ_FONTREQ,
	STR_COMMANDSEQ_ARGUMENTS,
	STR_COMMANDSEQ_SOURCE,
	STR_CLASSOPS_AND,
	STR_CLASSOPS_MATCH,
	STR_CLASSOPS_MATCHBITS,
	STR_CLASSOPS_MATCHCOMMENT,
	STR_CLASSOPS_MATCHDATE,
	STR_CLASSOPS_MATCHNAME,
	STR_CLASSOPS_MATCHSIZE,
	STR_CLASSOPS_MOVE,
	STR_CLASSOPS_MOVETO,
	STR_CLASSOPS_OR,
	STR_CLASSOPS_SEARCHFOR,
	STR_BY,
	STR_SELECT_HOTKEY_TO_SWAP,
	STR_SELECT_SECOND_HOTKEY_TO_SWAP,
	STR_MODULE_LIST_TITLE,
	STR_LANGUAGE_LIST_TITLE,
	STR_MODULE_LIST_CHECK_STRING,
	STR_LANGUAGE_LIST_CHECK_STRING,
	STR_SYS_CLOCK_KILOBYTES_FREE,
	STR_SYS_STARTUP_CONFIG,
	STR_MENU_DUPLICATE,
	STR_FILECLASS_DUPLICATE,
	STR_MENU_CLEARCLIPS,
	STR_REALLY_CLEAR_CLIPS,
	STR_SCREEN_GENERAL_DRAGREQUESTERS,
	STR_FORMAT_OWNER,
	STR_FORMAT_GROUP,
	STR_PALETTE_TINT,
	STR_PALETTE_PHARAOH,
	STR_PALETTE_SUNSET,
	STR_PALETTE_OCEAN,
	STR_PALETTE_STEEL,
	STR_PALETTE_CHOCOLATE,
	STR_PALETTE_PEWTER,
	STR_PALETTE_WINE,
	STR_PALETTE_A2024,
	STR_FTYPE_CLICKMCLICK,
	STR_FTYPE_DOUBLECLICK,
	STR_FUNCTION_COMMAND,
	STR_FUNCTION_AMIGADOS,
	STR_FUNCTION_WORKBENCH,
	STR_FUNCTION_BATCH,
	STR_FUNCTION_AREXX,
	STR_removed_tech,
	STR_MODE_WORKBENCH_CLONE,
	STR_MODE_WORKBENCH_USE,
	STR_COLOURS_TINY_GADS,
	STR_FORMAT_GROUPBITS,
	STR_MENUNAME_NEATSTUFF,
	STR_NEAT_PAINT_MODE,
	STR_PAINT_SELECT_COLOURS,
	STR_PAINT_STATE,
	STR_SCREEN_GENERAL_NEWLOOKMENUS,
	STR_SCREEN_GENERAL_TITLEBARSTATUS,
	STR_OP_UPDATE_PROGRESSIND_COPY,
	STR_SCREEN_MODE_USE,
	STR_SCREEN_GENERAL_WINDOWBORDERS,
	STR_SCREEN_MODE_CLONE,
	STR_SCREEN_SLIDERS,
	STR_OP_UPDATE_PROGRESS,
	STR_FONTPLACE_SCREEN,
	STR_FUNCTIONLIST_SETVAR,
	STR_COMMANDSEQ_VARIABLE,
	STR_SYS_VIEWPLAY_BESTMODEID,
	STR_FUNCTIONLIST_NOTIFY,
	STR_FUNCTIONLIST_PARENTLIST,

	STR_STRING_COUNT};
